/***********************************************************************\
 *                                APM/2                                *
 *      Copyright (C) by Stangl Roman (rstangl@vnet.ibm.com), 1997     *
 * This Code may be freely distributed, provided the Copyright isn't   *
 * removed, under the conditions indicated in the documentation.       *
 *                                                                     *
\***********************************************************************/
#pragma     strings(readonly)

#define     INCL_DOSFILEMGR
#define     INCL_DOSMISC
#define     INCL_DOSDEVICES
#define     INCL_DOSDEVIOCTL
#define     INCL_DOSERRORS
#include    <os2.h>

#include    <stdio.h>
#include    <stdlib.h>
#include    <iostream.h>

#ifndef LANG_ENGLISH
    #ifndef LANG_GERMAN
        #define LANG_ENGLISH
    #endif  /* LANG_GERMAN */
#endif  /* LANG_ENGLISH */

struct POWERINFO
{
USHORT  usParmLength;
USHORT  usBIOSFlags;
USHORT  usBIOSVersion;
USHORT  usSubsysVersion;
};

struct  POWEREVENT
{
USHORT  usSubID;
USHORT  usReserved;
USHORT  usData1;
USHORT  usData2;
};

struct  POWERSTATUS
{
USHORT  usParmLength;
USHORT  usPowerFlags;
UCHAR   ucACStatus;
UCHAR   ucBatteryStatus;
UCHAR   ucBatteryLife;
};


ULONG   StringWrite(char *pcString)
{
                                        /* STDOUT file handle is numerically 1 for all
                                           OS/2 processes */
#define STDOUT                          0x00000001

    ULONG   ulWriteCount;

    ulWriteCount=strlen(pcString);
    return(DosWrite(1, pcString, ulWriteCount, &ulWriteCount));
}
 
int     main(int argc, char *argv[])
{
    int         iReturnCode=0;
    USHORT      usRequest=(ULONG)-1;
    ULONG       ulVersion[2];
    ULONG       ulVersionFail=TRUE;
    APIRET      apiretRc=NO_ERROR;
    HFILE       hfileAPM=0;
    ULONG       ulAction=0;
    
                                        /* Copyright ... */
    StringWrite("\r\nAPM\\2 V1.00 - Power down your PC\r\n");
    StringWrite("Copyright (C) by Roman Stangl, 1997 (rstangl@vnet.ibm.com)\r\n\r\n");
#ifdef  LANG_ENGLISH
    StringWrite("APM\\2 allows you to put your workstation into APM standby, suspend or power off\r\n");
    StringWrite("mode.  This program is Freeware (and can be freely distributed,  as long as the\r\n");
    StringWrite("archive is kept complete), however you must not port it to  any of the inferior\r\n");
    StringWrite("Windows platforms!\r\n\r\n");
#endif  /* LANG_ENGLISH */
#ifdef  LANG_GERMAN
    StringWrite("APM\\2 erlaubt es Ihren Rechner in den APM standby, suspend oder power off Modus\r\n");
    StringWrite("zu bringen.  Diese Programm is Freeware und kann frei vertailt werden,  solange\r\n");
    StringWrite("das Archiv komplett bleibt, jede Portierung auf eine der technisch unterlegenen\r\n");
    StringWrite("Windows Plattformen ist ausdrcklich verboten!\r\n\r\n");
#endif  /* LANG_GERMAN */
                                        /* Check OS/2 version as only the Warp 4 APM device
                                           driver and kernel work correctly */
    if(DosQuerySysInfo(QSV_VERSION_MAJOR, QSV_VERSION_MINOR, ulVersion, sizeof(ulVersion))==NO_ERROR)
        {
        if((ulVersion[0]==20) && (ulVersion[1]>=40))
            ulVersionFail=FALSE;
        if(ulVersion[0]>20)
            ulVersionFail=FALSE;
        }
    if(ulVersionFail==TRUE)
        {
#ifdef  LANG_ENGLISH
        StringWrite("APM00001: Invalid OS/2 version detected.  Only the Warp 4 APM.SYS device driver\r\n");
        StringWrite("          and kernel are designed  to support the APM requests  (which does not\r\n");
        StringWrite("          mean your PC can't hang,  as APM is mainly  implemented at a hardware\r\n");
        StringWrite("          and BIOS level, not at the OS layer), though you can continue at your\r\n");
        StringWrite("          own risk (that is a CHKDSK during next boot)!\r\n\r\n");
#endif  /* LANG_ENGLISH */
#ifdef  LANG_GERMAN
        StringWrite("APM00001: Ungltige OS/2 Version. Nur der Warp 4 APM.SYS Treiber und der Warp 4\r\n");
        StringWrite("          Kernel untersttzen  APM Funktionen korrekt  (was aber keine Garantie\r\n");
        StringWrite("          dass Ihr PC  sich nicht dennoch aufhngt,  da APM hauptschlich durch\r\n");
        StringWrite("          die Hardware  und das BIOS  implementiert wird,  und  nicht durch das\r\n");
        StringWrite("          Betriebssystem,  Sie knnen jedoch auf eigne Gefahr  (also ein CHKDSK\r\n");
        StringWrite("          nach dem nchsten Neustart) fortfahren.\r\n\r\n");
#endif  /* LANG_GERMAN */
        iReturnCode=1;
        }
    if(argc>=2)
        usRequest=(SHORT)atoi(argv[1]);
                                        /* Check arguments */
    if((argc<2) || (usRequest==0) || (usRequest>3))
        {
#ifdef  LANG_ENGLISH
        StringWrite("Syntax: APM request\r\n");
        StringWrite("Where:  request  ... 1 to invoke APM standby\r\n");
        StringWrite("                 ... 2 to invoke APM suspend\r\n");
        StringWrite("                 ... 3 to invoke APM power off\r\n\r\n");
        StringWrite("APM00002: Invalid commandline syntax given.\r\n\r\n");
#endif  /* LANG_ENGLISH */
#ifdef  LANG_GERMAN
        StringWrite("Syntax: APM Funktion\r\n");
        StringWrite("Wobei:  Funktion  ... 1 um APM standby zu aktivieren\r\n");
        StringWrite("                  ... 2 um APM suspend zu aktivieren\r\n");
        StringWrite("                  ... 3 um APM power off zu aktivieren\r\n\r\n");
        StringWrite("APM00002: Ungltige Befehlszeile angegeben.\r\n\r\n");
#endif  /* LANG_GERMAN */
        iReturnCode=2;
        }
    while(iReturnCode<2)
        {
                                        /* Open APM.SYS */
        ulAction=0;
        apiretRc=DosOpen("\\DEV\\APM$", &hfileAPM, &ulAction, 0, FILE_NORMAL,
            OPEN_ACTION_OPEN_IF_EXISTS,
            OPEN_FLAGS_FAIL_ON_ERROR | OPEN_SHARE_DENYNONE | OPEN_ACCESS_READWRITE, NULL);
        if(apiretRc!=NO_ERROR)
            {
#ifdef  LANG_ENGLISH
            StringWrite("APM00003: No APM interface available. Please verify that you have installed the\r\n");
            StringWrite("          APM.SYS  device driver  (you can add it by selective install and that\r\n");
            StringWrite("          and that APM BIOS is enabled.\r\n\r\n");
#endif  /* LANG_ENGLISH */
#ifdef  LANG_GERMAN
            StringWrite("APM00003: Kein APM Schnittstelle verfgbar.  Stellen Sie bitte sicher, dass der\r\n");
            StringWrite("          Treiber  APM.SYS  (der mit dem  Installationsprogramm nachinstalliert\r\n");
            StringWrite("          werden kann) installiert, und das APM BIOS aktiviert ist.\r\n\r\n");
#endif  /* LANG_GERMAN */
            iReturnCode=3;
            break;
            }
                                        /* APM diagnostics */
        ULONG       ulReturnCode;
        ULONG       ulPacketSize;
        ULONG       ulDataSize;
//        POWERINFO   powerinfoAPM;
//        
//        memset(&powerinfoAPM, 0, sizeof(powerinfoAPM));
//        ulReturnCode=0;
//        powerinfoAPM.usParmLength=sizeof(powerinfoAPM);
//        ulPacketSize=sizeof(powerinfoAPM);
//        ulDataSize=sizeof(ulReturnCode);
//        apiretRc=DosDevIOCtl(hfileAPM, IOCTL_POWER, POWER_GETPOWERINFO,
//            &powerinfoAPM, ulPacketSize, &ulPacketSize,
//            &ulReturnCode, ulDataSize, &ulDataSize);
//        cout << "GetPowerInfo APM$: " << (int)apiretRc << endl;
//        cout << "GetPowerInfo ParmLength " << (int)powerinfoAPM.usParmLength << endl;
//        cout << "GetPowerInfo BIOSFlags " << (int)powerinfoAPM.usBIOSFlags << endl;
//        cout << "GetPowerInfo BIOSVersion " << (int)(powerinfoAPM.usBIOSVersion>>8) << "." << (int)(powerinfoAPM.usBIOSVersion & 0xFF) << endl;
//        cout << "GetPowerInfo SubsysVersion " << (int)powerinfoAPM.usSubsysVersion << endl;
//        cout << "GetPowerInfo ReturnCode " << (int)ulReturnCode << endl;
                                        /* Just be sure and enable APM */
        POWEREVENT  powereventAPM;
        
        memset(&powereventAPM, 0, sizeof(powereventAPM));
        ulReturnCode=0;
        powereventAPM.usSubID=0x0003;   /* Enable PWR MGMT function */
        ulPacketSize=sizeof(powereventAPM);
        ulDataSize=sizeof(ulReturnCode);
        apiretRc=DosDevIOCtl(hfileAPM, IOCTL_POWER, POWER_SENDPOWEREVENT,
            &powereventAPM, ulPacketSize, &ulPacketSize,
            &ulReturnCode, ulDataSize, &ulDataSize);
                                        /* Invoke APM request */
        memset(&powereventAPM, 0, sizeof(powereventAPM));
        ulReturnCode=0;
        powereventAPM.usSubID=0x0006;   /* Set PWR event */
        powereventAPM.usData1=0x0001;   /* All APM devices */
                                        /* APM request */
        powereventAPM.usData2=usRequest;
        ulPacketSize=sizeof(powereventAPM);
        ulDataSize=sizeof(ulReturnCode);
        apiretRc=DosDevIOCtl(hfileAPM, IOCTL_POWER, POWER_SENDPOWEREVENT,
            &powereventAPM, ulPacketSize, &ulPacketSize,
            &ulReturnCode, ulDataSize, &ulDataSize);
        if((apiretRc!=NO_ERROR) || (ulReturnCode!=0))
            {
#ifdef  LANG_ENGLISH
            StringWrite("APM00004: APM doesn't  accept your  request.  Please  verify that your  PC does\r\n");
            StringWrite("          support APM standby, suspend and power off requests.\r\n\r\n");
#endif  /* LANG_ENGLISH */
#ifdef  LANG_GERMAN
            StringWrite("APM00004: APM  untersttzt  die ausgewhlte  Funktion nicht.  Stellen Sie bitte\r\n");
            StringWrite("          sicher, dass Ihr PC APM standby, suspend und power off untersttzt.r\n\r\n");
#endif  /* LANG_GERMAN */
            iReturnCode=4;
            break;
            }
        break;
        }
    if(hfileAPM!=0)
        apiretRc=DosClose(hfileAPM);
    if(iReturnCode<=1)
        {
#ifdef  LANG_ENGLISH
        StringWrite("APM00005: Your (asynchronous) APM request should be performed shortly.\r\n"); 
#endif  /* LANG_ENGLISH */
#ifdef  LANG_GERMAN
        StringWrite("APM00005: Die (asynchron bearbeitete) APM Funktion wird in Krze durchgefhrt.\r\n"); 
#endif  /* LANG_GERMAN */
        }
    return(iReturnCode);
}
